package com.wall.wallpaper.hd;

import android.app.Application;
import android.content.Context;
import android.graphics.Typeface;
import android.util.Log;

import com.anythink.core.api.ATSDK;
import com.anythink.core.api.NetTrafficeCallback;
import com.wall.wallpaper.hd.ad.AdManager;
import com.wall.wallpaper.hd.tools.CommonUtils;
import com.wall.wallpaper.hd.tools.JsonData;
import com.wall.wallpaper.hd.tools.DbManager;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class WallApp extends Application {
    public static Context mAppContext;

    public static String TAG = "-------MyApp---------";
    public static Typeface defaultFont;


    private String animasName = "Animals.json";
    private String exName = "Experimental.json";
    private String filmName = "Film.json";
    private String natureName = "Nature.json";
    private String pattName = "Patterns.json";
    private String streetName = "Street.json";
    private String travelName = "Travel.json";
    private String wallpaperName = "Featured.json";
    private ExecutorService executor;
    private static List<String> CategoryNames = new ArrayList<>();
    private int i = 0;

    @Override
    public void onCreate() {
        super.onCreate();
        mAppContext = this;
        defaultFont = Typeface.createFromAsset(getAssets(), "custfont.ttf");
        initTop();
        DbManager.init(this);
        executor = Executors.newFixedThreadPool(8);
        String[] names = {wallpaperName, animasName, exName, filmName, natureName, pattName, streetName, travelName};

        try {
            for (String name : names) {
                InputStream open = getAssets().open(name);
                String covertStr = CommonUtils.getCovertStr(open);
                if (!covertStr.isEmpty()) {
                    String realName = name.substring(0, name.indexOf("."));
                    CategoryNames.add(realName);
                    executor.execute(new Runnable() {
                        @Override
                        public void run() {
                            i++;
                            Log.d(WallApp.TAG, "------------111");
                            JsonData.INSTANCE.getData(covertStr, realName);
//                            if (i == 8) {
//                                executor.shutdown();
//                                Log.d(MyWallpaper.TAG, "------------data complete");
//                            }

                        }
                    });
                }
            }


        } catch (IOException e) {
            throw new RuntimeException(e);
        }


    }

    public static List<String> getCategoryNames() {
        return CategoryNames;
    }


    private void initTop(){
        String APPId = "h67e3658322427";
        String AppKey = "aea386cf8d6f2dec3593d9d996ae1f5ed";
        ATSDK.checkIsEuTraffic(this, new NetTrafficeCallback() {

            @Override
            public void onResultCallback(boolean isEU) {
                if (isEU && ATSDK.getGDPRDataLevel( WallApp.mAppContext) == ATSDK.UNKNOWN) {
                    ATSDK.showGdprAuth(WallApp.mAppContext);
                }

            }

            @Override
            public void onErrorCallback(String errorMsg) {
            }
        });

        ATSDK.init( this, APPId, AppKey);
        //测试工具
//        ATDebuggerUITest.showDebuggerUI(this,"529b9d845e53ac839536d321c0b6be5f6928b24d");
        AdManager.loadAllAd();

    }
}
